import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class DefaultDialogButton extends StatelessWidget {
  final Widget? titel;
  final VoidCallback? onTap;
  final bool closeAfterTap;
  final Color? color;

  const DefaultDialogButton(
      {Key? key, this.titel, this.onTap, this.closeAfterTap = true, this.color})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Expanded(
      child: Material(
        color: color ?? DefaultColors.backgroundItem,
        child: InkWell(
          onTap: () {
            onTap?.call();
            if (closeAfterTap) {
              SplitRouterDelegate.instance.pop();
            }
          },
          child: Padding(
            padding: const EdgeInsets.symmetric(vertical: 10),
            child: DefaultTextStyle(
                style: TextStyles.textStyleSize(16).copyWith(
                    fontWeight: FontWeight.w500, color: DefaultColors.text),
                child: Center(
                  child: titel,
                )),
          ),
        ),
      ),
    );
  }
}
