import 'package:clean_android_design/clean_android_design.dart';

class PageCollectionMap {
  Map<String, KeyPage>? _map;
  String? _keyHome;
  String? _key404;

  PageCollectionMap({
    required String keyHome,
    required String key404,
    required List<KeyPage> pages,
  }) {
    _map = <String, KeyPage>{}
      ..addEntries(pages.map((page) => MapEntry(page.key, page)));
    this._keyHome = keyHome;
    this._key404 = key404;
  }

  bool containsKey(String key) {
    if (_map == null)
      throw Exception(
          "The PageCollectionMap instance was accessed before it was initialized (operator [])");
    return _map!.containsKey(key);
  }

  KeyPage operator [](String key) {
    if (_map == null)
      throw Exception(
          "The PageCollectionMap instance was accessed before it was initialized (operator [])");
    var page = _map![key];
    if (page == null)
      throw Exception(
          "Tried to access page key $key, but it couldn't be found in collection");
    return page;
  }

  KeyPage get pageHome {
    if (_map == null || _keyHome == null)
      throw Exception(
          "The PageCollectionMap instance was accessed before it was initialized (pageHome)");
    return this[_keyHome!];
  }

  KeyPage get page404 {
    if (_map == null || _key404 == null)
      throw Exception(
          "The PageCollectionMap instance was accessed before it was initialized (page404)");
    return this[_key404!];
  }
}
