import 'package:clean_android_design/src/settings/clean_android_design_style.dart';
import 'package:flutter/material.dart';

class SnackBarController {
  static GlobalKey<ScaffoldMessengerState>? rootScaffoldMessengerKey;

  static bool showText(String text) {
    return show(widget: Text(text));
  }

  static bool showIconAndText(IconData iconData, String text) {
    return show(
        widget: Row(
      children: [
        Padding(
          padding: const EdgeInsets.only(right: 7),
          child: Icon(iconData, color: DefaultColors.instanceDark.text),
        ),
        Text(text)
      ],
    ));
  }

  static bool showTextAndAction(
      String text, String action, void Function() onPressed) {
    return show(
      widget: Text(text),
      action: SnackBarAction(label: action, onPressed: onPressed),
    );
  }

  static bool show({Widget? widget, SnackBarAction? action}) {
    if (rootScaffoldMessengerKey == null) return false;

    try {
      rootScaffoldMessengerKey!.currentState!.hideCurrentSnackBar();
      rootScaffoldMessengerKey!.currentState!.showSnackBar(SnackBar(
        content: widget!,
        action: action,
      ));
    } catch (e) {}
    return true;
  }
}
