import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/cupertino.dart';

class ItemColumn extends StatelessWidget {
  final List<Widget> children;
  final MainAxisAlignment mainAxisAlignment;
  final CrossAxisAlignment crossAxisAlignment;
  final MainAxisSize mainAxisSize;

  const ItemColumn({
    Key? key,
    required this.children,
    this.mainAxisAlignment = MainAxisAlignment.start,
    this.crossAxisAlignment = CrossAxisAlignment.center,
    this.mainAxisSize = MainAxisSize.max,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      mainAxisAlignment: mainAxisAlignment,
      crossAxisAlignment: crossAxisAlignment,
      mainAxisSize: mainAxisSize,
      children: children
          .asMap()
          .map(
            (index, child) => MapEntry(
                index,
                ItemPosition(
                  child: child,
                  isFirst: index == 0,
                  isLast: index == (children.length - 1),
                  hasSeparationLine: index != (children.length - 1),
                )),
          )
          .values
          .toList(),
    );
  }
}
