import 'dart:collection';

class ItemSectionExtendedController {
  LinkedList<_ListenerEntry> _listeners = LinkedList<_ListenerEntry>();
  late bool _extended;
  bool get extended => _extended;

  ItemSectionExtendedController({bool extended = true})
      : this._extended = extended;

  void addListener(void Function(bool extended) listener) {
    _listeners.add(_ListenerEntry(listener));
  }

  void removeListener(listener) {
    for (final _ListenerEntry entry in _listeners) {
      if (entry.listener == listener) {
        entry.unlink();
        return;
      }
    }
  }

  void setExtended(bool extended) {
    _extended = extended;
  }

  void setExtendedAndUpdate(bool extended) {
    _extended = extended;
    for (final _ListenerEntry entry in _listeners) {
      if (entry.list != null) entry.listener(_extended);
    }
  }
}

class _ListenerEntry extends LinkedListEntry<_ListenerEntry> {
  _ListenerEntry(this.listener);
  final void Function(bool extended) listener;
}
