import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class ItemSectionTitle extends StatelessWidget {
  final ItemSectionExtendedController? controller;
  final Widget? title;

  const ItemSectionTitle({
    Key? key,
    this.controller,
    this.title,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return title != null
        ? Padding(
            padding: const EdgeInsets.symmetric(horizontal: 20),
            child: Material(
              color: DefaultColors.background,
              borderRadius: BorderRadius.circular(6),
              child: InkWell(
                onTap: controller == null
                    ? null
                    : () =>
                        controller?.setExtendedAndUpdate(!controller!.extended),
                borderRadius: BorderRadius.circular(6),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    title != null
                        ? Padding(
                            padding: const EdgeInsets.symmetric(
                                horizontal: 5, vertical: 5),
                            child: DefaultTextStyle(
                              style: TextStyles.textStyleSize(14).copyWith(
                                color: DefaultColors.textLight,
                                fontWeight: FontWeight.w600,
                              ),
                              child: title!,
                            ),
                          )
                        : Container(),
                    controller != null
                        ? Padding(
                            padding: const EdgeInsets.symmetric(horizontal: 5),
                            child: Icon(
                                controller?.extended ?? true
                                    ? Icons.keyboard_arrow_up
                                    : Icons.keyboard_arrow_down,
                                color: DefaultColors.textLight),
                          )
                        : Container(),
                  ],
                ),
              ),
            ),
          )
        : Container();
  }
}
