import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';

class HoverListItem extends StatefulWidget {
  final Widget Function(bool hover)? leadingBuilder;
  final Widget Function(bool hover)? trailingBuilder;
  final Widget Function(bool hover)? titleBuilder;
  final Widget Function(bool hover)? descriptionBuilder;
  final GestureTapCallback? onTap;
  final HighlightController? highlightController;

  const HoverListItem({
    Key? key,
    this.onTap,
    this.highlightController,
    this.leadingBuilder,
    this.trailingBuilder,
    this.titleBuilder,
    this.descriptionBuilder,
  }) : super(key: key);

  @override
  _HoverListItemState createState() => _HoverListItemState();
}

class _HoverListItemState extends State<HoverListItem> {
  late bool hover;

  @override
  void initState() {
    super.initState();

    hover = !kIsWeb;
  }

  @override
  Widget build(BuildContext context) {
    return DefaultListItem(
      onHover: kIsWeb
          ? (value) {
              setState(() => hover = value);
            }
          : null,
      description: widget.descriptionBuilder?.call(hover),
      leading: widget.leadingBuilder?.call(hover),
      title: widget.titleBuilder?.call(hover),
      trailing: widget.trailingBuilder?.call(hover),
      onTap: widget.onTap,
      highlightController: widget.highlightController,
    );
  }
}
