import 'package:flutter/material.dart';

class ItemListBehavior extends InheritedWidget {
  final Widget child;
  final bool isSelected;

  // if returns true, the item can call their own onTap-functions
  final bool Function()? onTapList;
  final bool Function()? onLongTapList;

  ItemListBehavior({
    required this.child,
    this.isSelected = false,
    this.onTapList,
    this.onLongTapList,
  }) : super(child: child);

  static ItemListBehavior? of(BuildContext context) {
    return context.dependOnInheritedWidgetOfExactType<ItemListBehavior>();
  }

  @override
  bool updateShouldNotify(covariant InheritedWidget oldWidget) => true;
}
