import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class DefaultMenuBar extends StatefulWidget {
  final List<Widget?>? menuButtons;

  const DefaultMenuBar({
    Key? key,
    this.menuButtons,
  }) : super(key: key);

  @override
  State<DefaultMenuBar> createState() => _DefaultMenuBarState();
}

class _DefaultMenuBarState extends State<DefaultMenuBar> {
  @override
  Widget build(BuildContext context) {
    var children = widget.menuButtons?.whereNotNull() ?? [];
    return children.length > 0 ? buildBar(children) : Container(height: 0);
  }

  Widget buildBar(List<Widget> children) {
    return Container(
      height: 60,
      color: DefaultColors.background,
      child: Row(
        mainAxisAlignment: MainAxisAlignment.spaceEvenly,
        crossAxisAlignment: CrossAxisAlignment.center,
        children: children,
      ),
    );
  }
}
