import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class ScaffoldShimmer extends StatelessWidget {
  const ScaffoldShimmer({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        ItemSectionWidget(
            title: Container(
              width: 80,
              height: 20,
              decoration: BoxDecoration(
                color: DefaultColors.shimmerBackground,
                borderRadius: BorderRadius.circular(50),
              ),
            ),
            children: [
              ShimmerListItem(),
              ShimmerListItem(),
              ShimmerListItem(),
            ]),
        Container(height: 5),
        ItemSectionWidget(
            title: Container(
              width: 80,
              height: 20,
              decoration: BoxDecoration(
                color: DefaultColors.shimmerBackground,
                borderRadius: BorderRadius.circular(50),
              ),
            ),
            children: [
              ShimmerListItem(),
              ShimmerListItem(
                descriptionShimmer: false,
              ),
            ]),
        Container(height: 5),
        ItemSectionWidget(
            title: Container(
              width: 80,
              height: 20,
              decoration: BoxDecoration(
                color: DefaultColors.shimmerBackground,
                borderRadius: BorderRadius.circular(50),
              ),
            ),
            children: [
              ShimmerListItem(),
              ShimmerListItem(),
              ShimmerListItem(textShimmer: false),
              ShimmerListItem(textShimmer: false),
              ShimmerListItem(),
            ]),
      ],
    );
  }
}
