import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class ShimmerListItem extends StatelessWidget {
  final bool leadingShimmer;
  final bool textShimmer;
  final bool descriptionShimmer;

  const ShimmerListItem({
    Key? key,
    this.leadingShimmer = true,
    this.textShimmer = true,
    this.descriptionShimmer = true,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return DefaultListItem(
      leading: leadingShimmer
          ? ShimmerLoading(
              child: Container(
                width: 35,
                height: 35,
                decoration: BoxDecoration(
                  color: DefaultColors.shimmerBackground,
                  borderRadius: BorderRadius.circular(50),
                ),
              ),
            )
          : null,
      title: textShimmer
          ? ShimmerLoading(
              child: Container(
                width: Shimmer.of(context)?.getRandomShort ?? 100,
                height: 20,
                decoration: BoxDecoration(
                  color: DefaultColors.shimmerBackground,
                  borderRadius: BorderRadius.circular(50),
                ),
              ),
            )
          : null,
      description: descriptionShimmer
          ? Padding(
              padding: EdgeInsets.only(top: textShimmer ? 3.0 : 0.0),
              child: ShimmerLoading(
                child: Container(
                  width: Shimmer.of(context)?.getRandomLong ?? 250,
                  height: 15,
                  decoration: BoxDecoration(
                    color: DefaultColors.shimmerBackground,
                    borderRadius: BorderRadius.circular(50),
                  ),
                ),
              ),
            )
          : null,
    );
  }
}
