import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class ShimmerTextFieldWidget extends StatelessWidget {
  const ShimmerTextFieldWidget({
    Key? key,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return DefaultFieldWidget(
      title: ShimmerLoading(
        child: Container(
          width: Shimmer.of(context)?.getRandomShort ?? 100,
          height: 12,
          decoration: BoxDecoration(
            color: DefaultColors.shimmerBackground,
            borderRadius: BorderRadius.circular(50),
          ),
        ),
      ),
      childPadding:
          const EdgeInsets.only(left: 30, right: 30, bottom: 8, top: 3),
      child: ShimmerLoading(
        child: Container(
          width: Shimmer.of(context)?.getRandomLong ?? 250,
          height: 20,
          decoration: BoxDecoration(
            color: DefaultColors.shimmerBackground,
            borderRadius: BorderRadius.circular(50),
          ),
        ),
      ),
    );
  }
}
