import 'package:clean_android_design/clean_android_design.dart';
import 'package:flutter/material.dart';

class UpdateKeyBuilder extends StatefulWidget {
  final ForceUpdateKey forceUpdateKey;
  final Widget Function(BuildContext) builder;

  const UpdateKeyBuilder({
    Key? key,
    required this.forceUpdateKey,
    required this.builder,
  }) : super(key: key);

  @override
  State<UpdateKeyBuilder> createState() => _UpdateKeyBuilderState();
}

class _UpdateKeyBuilderState extends State<UpdateKeyBuilder> {
  late Key key;

  @override
  void initState() {
    super.initState();

    key = UniqueKey();
  }

  @override
  Widget build(BuildContext context) {
    widget.forceUpdateKey.removeListener(listener);
    widget.forceUpdateKey.addListener(listener);
    return widget.builder(context);
  }

  void listener() {
    if (mounted)
      setState(() {
        print("New Key");
        key = UniqueKey();
      });
  }
}
